module;

#include <windows.h>

export module pige.winapi.msglog:application;

export import pige.winapi;
export import :window;

namespace pige::winapi
{
	export class logging_app : public application
	{
	public:
		logging_app(HINSTANCE instance)
			: application{ instance }
		{
			logger::start_section(L"Application Created");
		}

		using application::run;

		[[nodiscard]] int run(int show_command) override
		{
			logging_window w{ instance(), L"Logging Window" };
			return run(show_command, w);
		}

		[[nodiscard]] int run(int show_command, window &main_window) override
		{
			logger::end_section(); //end of Application Created section
			logger::start_section(L"Application Starting");
			return application::run(show_command, main_window);
		}

	protected:

		[[nodiscard]] int main_loop() override
		{
			logger::end_section(); //end of Application Starting
			MSG msg{};
			BOOL result;
			int counter = 0;
			while (true)
			{
				logger::start_section(L"Message loop waiting");
				if (0 == (result = GetMessageW(&msg, nullptr, 0, 0)))
					break;
				if (result < 0)
					throw winapi::winapi_error{};
				logger::end_section();

				logger::start_section(L"Message loop received", counter ,msg);
				TranslateMessage(&msg);
				DispatchMessageW(&msg);
				logger::end_section(L"Message", counter, L"processed", std::make_pair(msg, result));
				++counter;
			}
			result = static_cast<int>(msg.wParam);
			logger::end_section(L"Last message", msg, L"Exit code:", result);
			return result;
		}
	};
}