module;

#include <windows.h>

export module pige.winapi.msglog:format.name_maps;

import std;
import pige.utility;
import :format.common_types;

using namespace pige::utility;


//Creates mapping from virtual key codes to names
vk_map createVKMap()
{
#define ADD_VK(vk_id) { vk_code{vk_id}, L ## #vk_id }
	return {
		ADD_VK(VK_LBUTTON),			ADD_VK(VK_RBUTTON),			ADD_VK(VK_CANCEL),			ADD_VK(VK_MBUTTON),
		ADD_VK(VK_XBUTTON1),		ADD_VK(VK_XBUTTON2),		ADD_VK(VK_BACK),			ADD_VK(VK_TAB),
		ADD_VK(VK_CLEAR),			ADD_VK(VK_RETURN),			ADD_VK(VK_SHIFT),			ADD_VK(VK_CONTROL),
		ADD_VK(VK_MENU),			ADD_VK(VK_PAUSE),			ADD_VK(VK_CAPITAL),			ADD_VK(VK_KANA),
		ADD_VK(VK_HANGEUL),			ADD_VK(VK_HANGUL),			ADD_VK(VK_JUNJA),			ADD_VK(VK_FINAL),
		ADD_VK(VK_HANJA),			ADD_VK(VK_KANJI),			ADD_VK(VK_ESCAPE),			ADD_VK(VK_CONVERT),
		ADD_VK(VK_NONCONVERT),		ADD_VK(VK_ACCEPT),			ADD_VK(VK_MODECHANGE),		ADD_VK(VK_SPACE),
		ADD_VK(VK_PRIOR),			ADD_VK(VK_NEXT),			ADD_VK(VK_END),				ADD_VK(VK_HOME),
		ADD_VK(VK_LEFT),			ADD_VK(VK_UP),				ADD_VK(VK_RIGHT),			ADD_VK(VK_DOWN),
		ADD_VK(VK_SELECT),			ADD_VK(VK_PRINT),			ADD_VK(VK_EXECUTE),			ADD_VK(VK_SNAPSHOT),
		ADD_VK(VK_INSERT),			ADD_VK(VK_DELETE),			ADD_VK(VK_HELP),			ADD_VK(VK_LWIN),
		ADD_VK(VK_RWIN),			ADD_VK(VK_APPS),			ADD_VK(VK_SLEEP),			ADD_VK(VK_NUMPAD0),
		ADD_VK(VK_NUMPAD1),			ADD_VK(VK_NUMPAD2),			ADD_VK(VK_NUMPAD3),			ADD_VK(VK_NUMPAD4),
		ADD_VK(VK_NUMPAD5),			ADD_VK(VK_NUMPAD6),			ADD_VK(VK_NUMPAD7),			ADD_VK(VK_NUMPAD8),
		ADD_VK(VK_NUMPAD9),			ADD_VK(VK_MULTIPLY),		ADD_VK(VK_ADD),				ADD_VK(VK_SEPARATOR),
		ADD_VK(VK_SUBTRACT),		ADD_VK(VK_DECIMAL),			ADD_VK(VK_DIVIDE),			ADD_VK(VK_F1),
		ADD_VK(VK_F2),				ADD_VK(VK_F3),				ADD_VK(VK_F4),				ADD_VK(VK_F5),
		ADD_VK(VK_F6),				ADD_VK(VK_F7),				ADD_VK(VK_F8),				ADD_VK(VK_F9),
		ADD_VK(VK_F10),				ADD_VK(VK_F11),				ADD_VK(VK_F12),				ADD_VK(VK_F13),
		ADD_VK(VK_F14),				ADD_VK(VK_F15),				ADD_VK(VK_F16),				ADD_VK(VK_F17),
		ADD_VK(VK_F18),				ADD_VK(VK_F19),				ADD_VK(VK_F20),				ADD_VK(VK_F21),
		ADD_VK(VK_F22),				ADD_VK(VK_F23),				ADD_VK(VK_F24),				ADD_VK(VK_NAVIGATION_VIEW),
		ADD_VK(VK_NAVIGATION_MENU),	ADD_VK(VK_NAVIGATION_UP),	ADD_VK(VK_NAVIGATION_DOWN),	ADD_VK(VK_NAVIGATION_LEFT),
		ADD_VK(VK_NAVIGATION_RIGHT),ADD_VK(VK_NAVIGATION_ACCEPT),ADD_VK(VK_NAVIGATION_CANCEL),ADD_VK(VK_NUMLOCK),
		ADD_VK(VK_SCROLL),			ADD_VK(VK_OEM_NEC_EQUAL),	ADD_VK(VK_OEM_FJ_JISHO),	ADD_VK(VK_OEM_FJ_MASSHOU),
		ADD_VK(VK_OEM_FJ_TOUROKU),	ADD_VK(VK_OEM_FJ_LOYA),		ADD_VK(VK_OEM_FJ_ROYA),		ADD_VK(VK_LSHIFT),
		ADD_VK(VK_RSHIFT),			ADD_VK(VK_LCONTROL),		ADD_VK(VK_RCONTROL),		ADD_VK(VK_LMENU),
		ADD_VK(VK_RMENU),			ADD_VK(VK_BROWSER_BACK),	ADD_VK(VK_BROWSER_FORWARD),	ADD_VK(VK_BROWSER_REFRESH),
		ADD_VK(VK_BROWSER_STOP),	ADD_VK(VK_BROWSER_SEARCH),	ADD_VK(VK_BROWSER_FAVORITES),ADD_VK(VK_BROWSER_HOME),
		ADD_VK(VK_VOLUME_MUTE),		ADD_VK(VK_VOLUME_DOWN),		ADD_VK(VK_VOLUME_UP),		ADD_VK(VK_MEDIA_NEXT_TRACK),
		ADD_VK(VK_MEDIA_PREV_TRACK),ADD_VK(VK_MEDIA_STOP),		ADD_VK(VK_MEDIA_PLAY_PAUSE),ADD_VK(VK_LAUNCH_MAIL),
		ADD_VK(VK_LAUNCH_MEDIA_SELECT),	ADD_VK(VK_LAUNCH_APP1),	ADD_VK(VK_LAUNCH_APP2),		ADD_VK(VK_OEM_1),
		ADD_VK(VK_OEM_PLUS),		ADD_VK(VK_OEM_COMMA),		ADD_VK(VK_OEM_MINUS),		ADD_VK(VK_OEM_PERIOD),
		ADD_VK(VK_OEM_2),			ADD_VK(VK_OEM_3),			ADD_VK(VK_GAMEPAD_A),		ADD_VK(VK_GAMEPAD_B),
		ADD_VK(VK_GAMEPAD_X),		ADD_VK(VK_GAMEPAD_Y),		ADD_VK(VK_GAMEPAD_RIGHT_SHOULDER),
		ADD_VK(VK_GAMEPAD_LEFT_SHOULDER),	ADD_VK(VK_GAMEPAD_LEFT_TRIGGER),	ADD_VK(VK_GAMEPAD_RIGHT_TRIGGER),
		ADD_VK(VK_GAMEPAD_DPAD_UP),			ADD_VK(VK_GAMEPAD_DPAD_DOWN),		ADD_VK(VK_GAMEPAD_DPAD_LEFT),
		ADD_VK(VK_GAMEPAD_DPAD_RIGHT),		ADD_VK(VK_GAMEPAD_MENU),			ADD_VK(VK_GAMEPAD_VIEW),
		ADD_VK(VK_GAMEPAD_LEFT_THUMBSTICK_BUTTON),	ADD_VK(VK_GAMEPAD_RIGHT_THUMBSTICK_BUTTON),
		ADD_VK(VK_GAMEPAD_LEFT_THUMBSTICK_UP),		ADD_VK(VK_GAMEPAD_LEFT_THUMBSTICK_DOWN),
		ADD_VK(VK_GAMEPAD_LEFT_THUMBSTICK_RIGHT),	ADD_VK(VK_GAMEPAD_LEFT_THUMBSTICK_LEFT),
		ADD_VK(VK_GAMEPAD_RIGHT_THUMBSTICK_UP),		ADD_VK(VK_GAMEPAD_RIGHT_THUMBSTICK_DOWN),
		ADD_VK(VK_GAMEPAD_RIGHT_THUMBSTICK_RIGHT),	ADD_VK(VK_GAMEPAD_RIGHT_THUMBSTICK_LEFT),
		ADD_VK(VK_OEM_4),			ADD_VK(VK_OEM_5),			ADD_VK(VK_OEM_6),			ADD_VK(VK_OEM_7),
		ADD_VK(VK_OEM_8),			ADD_VK(VK_OEM_AX),			ADD_VK(VK_OEM_102),			ADD_VK(VK_ICO_HELP),
		ADD_VK(VK_ICO_00),			ADD_VK(VK_PROCESSKEY),		ADD_VK(VK_ICO_CLEAR),		ADD_VK(VK_PACKET),
		ADD_VK(VK_OEM_RESET),		ADD_VK(VK_OEM_JUMP),		ADD_VK(VK_OEM_PA1),			ADD_VK(VK_OEM_PA2),
		ADD_VK(VK_OEM_PA3),			ADD_VK(VK_OEM_WSCTRL),		ADD_VK(VK_OEM_CUSEL),		ADD_VK(VK_OEM_ATTN),
		ADD_VK(VK_OEM_FINISH),		ADD_VK(VK_OEM_COPY),		ADD_VK(VK_OEM_AUTO),		ADD_VK(VK_OEM_ENLW),
		ADD_VK(VK_OEM_BACKTAB),		ADD_VK(VK_ATTN),			ADD_VK(VK_CRSEL),			ADD_VK(VK_EXSEL),
		ADD_VK(VK_EREOF),			ADD_VK(VK_PLAY),			ADD_VK(VK_ZOOM),			ADD_VK(VK_NONAME),
		ADD_VK(VK_PA1),				ADD_VK(VK_OEM_CLEAR),
	};
#undef ADD_VK
}

//Creates mapping from hit test results to names
ht_map createHTMap()
{
#define ADD_HT(ht_id) { hit_test{ht_id}, L ## #ht_id }
		return {
			ADD_HT(HTERROR),	ADD_HT(HTTRANSPARENT),	ADD_HT(HTNOWHERE),		ADD_HT(HTCLIENT),
			ADD_HT(HTCAPTION),	ADD_HT(HTSYSMENU),		ADD_HT(HTGROWBOX),		ADD_HT(HTMENU),
			ADD_HT(HTHSCROLL),	ADD_HT(HTVSCROLL),		ADD_HT(HTMINBUTTON),	ADD_HT(HTMAXBUTTON),
			ADD_HT(HTLEFT),		ADD_HT(HTRIGHT),		ADD_HT(HTTOP),			ADD_HT(HTTOPLEFT),
			ADD_HT(HTTOPRIGHT),	ADD_HT(HTBOTTOM),		ADD_HT(HTBOTTOMLEFT),	ADD_HT(HTBOTTOMRIGHT),
			ADD_HT(HTBORDER),	ADD_HT(HTOBJECT),		ADD_HT(HTCLOSE),		ADD_HT(HTHELP)
		};
#undef ADD_HT
}

//Creates mapping from system command types to names
sc_map createSCMap()
{
#define ADD_SC(sc_id) { sys_cmd{sc_id}, L ## #sc_id }
	return {
		ADD_SC(SC_SIZE),		ADD_SC(SC_MOVE),			ADD_SC(SC_MINIMIZE),	ADD_SC(SC_MAXIMIZE),
		ADD_SC(SC_NEXTWINDOW),	ADD_SC(SC_PREVWINDOW),		ADD_SC(SC_CLOSE),		ADD_SC(SC_VSCROLL),
		ADD_SC(SC_HSCROLL),		ADD_SC(SC_MOUSEMENU),		ADD_SC(SC_KEYMENU),		ADD_SC(SC_ARRANGE),
		ADD_SC(SC_RESTORE),		ADD_SC(SC_TASKLIST),		ADD_SC(SC_SCREENSAVE),	ADD_SC(SC_HOTKEY),
		ADD_SC(SC_DEFAULT),		ADD_SC(SC_MONITORPOWER),	ADD_SC(SC_CONTEXTHELP),	ADD_SC(SC_SEPARATOR),
	};
#undef ADD_SC
}

ac_map createACMap()
{
#define ADD_AC(ac_id) { app_cmd{ ac_id }, L ## #ac_id }
	return {
		ADD_AC(APPCOMMAND_BROWSER_BACKWARD),
		ADD_AC(APPCOMMAND_BROWSER_FORWARD),
		ADD_AC(APPCOMMAND_BROWSER_REFRESH),
		ADD_AC(APPCOMMAND_BROWSER_STOP),
		ADD_AC(APPCOMMAND_BROWSER_SEARCH),
		ADD_AC(APPCOMMAND_BROWSER_FAVORITES),
		ADD_AC(APPCOMMAND_BROWSER_HOME),
		ADD_AC(APPCOMMAND_VOLUME_MUTE),
		ADD_AC(APPCOMMAND_VOLUME_DOWN),
		ADD_AC(APPCOMMAND_VOLUME_UP),
		ADD_AC(APPCOMMAND_MEDIA_NEXTTRACK),
		ADD_AC(APPCOMMAND_MEDIA_PREVIOUSTRACK),
		ADD_AC(APPCOMMAND_MEDIA_STOP),
		ADD_AC(APPCOMMAND_MEDIA_PLAY_PAUSE),
		ADD_AC(APPCOMMAND_LAUNCH_MAIL),
		ADD_AC(APPCOMMAND_LAUNCH_MEDIA_SELECT),
		ADD_AC(APPCOMMAND_LAUNCH_APP1),
		ADD_AC(APPCOMMAND_LAUNCH_APP2),
		ADD_AC(APPCOMMAND_BASS_DOWN),
		ADD_AC(APPCOMMAND_BASS_BOOST),
		ADD_AC(APPCOMMAND_BASS_UP),
		ADD_AC(APPCOMMAND_TREBLE_DOWN),
		ADD_AC(APPCOMMAND_TREBLE_UP),
		ADD_AC(APPCOMMAND_MICROPHONE_VOLUME_MUTE),
		ADD_AC(APPCOMMAND_MICROPHONE_VOLUME_DOWN),
		ADD_AC(APPCOMMAND_MICROPHONE_VOLUME_UP),
		ADD_AC(APPCOMMAND_HELP),
		ADD_AC(APPCOMMAND_FIND),
		ADD_AC(APPCOMMAND_NEW),
		ADD_AC(APPCOMMAND_OPEN),
		ADD_AC(APPCOMMAND_CLOSE),
		ADD_AC(APPCOMMAND_SAVE),
		ADD_AC(APPCOMMAND_PRINT),
		ADD_AC(APPCOMMAND_UNDO),
		ADD_AC(APPCOMMAND_REDO),
		ADD_AC(APPCOMMAND_COPY),
		ADD_AC(APPCOMMAND_CUT),
		ADD_AC(APPCOMMAND_PASTE),
		ADD_AC(APPCOMMAND_REPLY_TO_MAIL),
		ADD_AC(APPCOMMAND_FORWARD_MAIL),
		ADD_AC(APPCOMMAND_SEND_MAIL),
		ADD_AC(APPCOMMAND_SPELL_CHECK),
		ADD_AC(APPCOMMAND_DICTATE_OR_COMMAND_CONTROL_TOGGLE),
		ADD_AC(APPCOMMAND_MIC_ON_OFF_TOGGLE),
		ADD_AC(APPCOMMAND_CORRECTION_LIST),
		ADD_AC(APPCOMMAND_MEDIA_PLAY),
		ADD_AC(APPCOMMAND_MEDIA_PAUSE),
		ADD_AC(APPCOMMAND_MEDIA_RECORD),
		ADD_AC(APPCOMMAND_MEDIA_FAST_FORWARD),
		ADD_AC(APPCOMMAND_MEDIA_REWIND),
		ADD_AC(APPCOMMAND_MEDIA_CHANNEL_UP),
		ADD_AC(APPCOMMAND_MEDIA_CHANNEL_DOWN),
		ADD_AC(APPCOMMAND_DELETE),
		ADD_AC(APPCOMMAND_DWM_FLIP3D)
	};
#undef ADD_AC
}

export {
	//Stores mapping from virtual key codes to names
	const vk_map vkMap = createVKMap();
	//Stores mapping from hit test result to names
	const ht_map htMap = createHTMap();
	//Stores mapping from system command types to names
	const sc_map scMap = createSCMap();
	//Stores mapping from application command types to names
	const ac_map acMap = createACMap();
	//Caches window names
	hwnd_map wndMap{};

}